#ifndef _MNKPASSWORDKEEPERMAINWINDOW_H_
#define _MNKPASSWORDKEEPERMAINWINDOW_H_

#include <QString>

#define VERSION "1.0.0"

#include "mnkCrypt.H"
#include "mnkPassword.H"
#include "mnkPasswordMakerDialog.H"

#include "ui_mnkPasswordKeeper.h"

class mnkPasswordKeeperMainWindow : public QMainWindow, public Ui::MainWindow
{
  Q_OBJECT

public:
  mnkPasswordKeeperMainWindow(QMainWindow *parent = NULL);
  ~mnkPasswordKeeperMainWindow();
  bool openReadFile(QString fileName);

public slots:
  void removeButtonPushed(void);
  void newButtonPushed(void);

//  void addButtonPushed(void);
//  void deleteButtonPushed(void);
  void applyButtonPushed(void);
  void applyTextChanged(const QString &);
//  void clearButtonPushed(void);

  void fileOpen(const QString &path = QString());
  void fileSave(void);
  void fileSaveAs(const QString &path = QString());
  bool fileClose(void);
  void fileExit(void);
  void dockShow(void);
  void aboutShow(void);
  void filterFocus(void);

  void itemChanged(QListWidgetItem*, QListWidgetItem*);

  void reloadList(void);
  void filterEdited(const QString &);
  void showMasterDialog(void);
  void showGenerator(void);

private:
  QString fileName;
  QList<mnkPassword*> passwordList;

  mnkPassword* currentPassword;
  QListWidgetItem* currentItem;

  bool isModified;

  mnkCrypt *myCryptInterface;
  mnkPasswordMakerDialog *generatorDialog;

  QAction *actionFilterFocus;

  QString masterPassword;
};

#define DEFAULTFILE QString("passworddb.xmls")

/* Default status timeout */
#define STM 60000

/* Some coding/decoding macros */
#define ENCODE(x) mnkPassword::encode(mnkCodingTools::uuEncode(myCryptInterface->mnkEncryptArray(x)))
//#define DECODE(x) mnkCodingTools::uuDecode(mnkPassword::decode(x))
#define DECODE(x) \
    myCryptInterface->mnkDecryptArray(mnkCodingTools::uuDecodeToByteArray(mnkPassword::decode(x).toAscii()))

#endif
